﻿using System.Windows.Forms;

namespace mosaic {
    public partial class RenderDialog : Form {
        public delegate void RenderFunction();

        private RenderFunction renderFunc;

        /// <summary>
        /// Ctor
        /// </summary>
        /// <param name="r">The render function to store</param>
        public RenderDialog(RenderFunction r) {
            InitializeComponent();
            renderFunc = r;
        }

        /// <summary>
        /// Executes the stored render function, closes upon completion
        /// </summary>
        public void Render() {
            progressBar1.Refresh();

            renderFunc();
            Close();
        }

        public double ProgressValue {
            set {
                progressBar1.Value = (int) (value*progressBar1.Maximum);
            }
        }
    }
}
